pipeline {
    agent any
    tools{
        nodejs 'node'
        docekrTool 'docker'
    }
    triggers{
        githubPush()
    }

    environment{
        DOCKERHUB_CREDENTIALS=credentials('my_docker_cred')
        IMAGE_NAME='seeshellol/mynodesapp'
    }
    
    stages {
        stage('Clean'){
            steps{
                cleanWs()
            }
        }
        stage('Clone Repo'){
            steps{
                git branch: 'main',
                url:'https://github.com/seeshellol/nodejs-my-proj.git'
            }
        }
        stage('Build') {
            steps {
               sh 'npm ci'
            }
        }
        
        stage('Test') {
            steps {
                sh 'npm test'
            }
        }
        stage('Docker login') {
            steps {
                sh 'docker login -u $DOCKERHUB_CREDENTIALS_USR -p $DOCKERHUB_CREDENTIALS_PSW'
            }
        }

        stage('Docker build and tag'){
            steps{
                sh 'docker build -t ${IMAGE_NAME} -f'
            }
        }
        
        stage('Deploy') {
            steps {
                // Deploy your application here
            }
        }
    }
}
